home
***
CD-ROM
|
disk
|
FTP
|
other
***
search
/
PC World Komputer 2010 April
/
PCWorld0410.iso
/
hity wydania
/
Ubuntu 9.10 PL
/
karmelkowy-koliberek-desktop-9.10-i386-PL.iso
/
casper
/
filesystem.squashfs
/
usr
/
lib
/
linux-boot-probes
/
50mounted-tests
Wrap
Text File
|
2009-09-14
|
2KB
|
70 lines
#!/bin/sh
# Sub-tests that require a mounted partition.
. /usr/share/os-prober/common.sh
set -e
partition=$1
tmpmnt=/var/lib/os-prober/mount
if [ ! -d $tmpmnt ]; then
mkdir $tmpmnt
fi
types="$(fs_type "$partition")" || types=NOT-DETECTED
if [ "$types" = NOT-DETECTED ]; then
debug "$1 type not recognised; skipping"
exit 0
elif [ "$types" = swap ]; then
debug "$1 is a swap partition; skipping"
exit 0
elif [ "$types" = crypto_LUKS ]; then
debug "$1 is a LUKS partition; skipping"
exit 0
elif [ "$types" = ntfs ]; then
if type ntfs-3g >/dev/null 2>&1; then
types='ntfs-3g ntfs'
fi
elif [ -z "$types" ]; then
if type cryptsetup >/dev/null 2>&1 && \
cryptsetup luksDump "$partition" >/dev/null 2>&1; then
debug "$1 is a LUKS partition; skipping"
exit 0
fi
types="$(grep -v nodev /proc/filesystems)"
fi
for type in $types; do
if mount -o ro -t $type $partition $tmpmnt 2>/dev/null; then
mountboot="$(linux_mount_boot "$partition" "$tmpmnt")"
bootpart="${mountboot%% *}"
mounted="${mountboot#* }"
for test in /usr/lib/linux-boot-probes/mounted/*; do
if [ -f $test ] && [ -x $test ]; then
debug "running $test $partition $bootpart $tmpmnt $type"
if $test "$partition" "$bootpart" "$tmpmnt" "$type"; then
debug "$test succeeded"
umount $tmpmnt/boot 2>/dev/null || true
if ! umount $tmpmnt; then
warn "failed to umount $tmpmnt"
fi
rmdir $tmpmnt || true
exit 0
fi
fi
done
umount $tmpmnt/boot 2>/dev/null || true
if ! umount $tmpmnt; then
warn "failed to umount $tmpmnt"
fi
break
fi
done
rmdir $tmpmnt || true
# No tests found anything.
exit 1